<html>
<head>
<title>OgreShaderExPerPixelLighting.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderExPerPixelLighting.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderExPerPixelLighting_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderExPerPixelLighting_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderExPerPixelLighting_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef RTSHADER_SYSTEM_BUILD_EXT_SHADERS</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="OgreShaderParameter_8h.html">OgreShaderParameter.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderSubRenderState_8h.html">OgreShaderSubRenderState.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector4_8h.html">OgreVector4.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreLight_8h.html">OgreLight.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 <span class="keyword">namespace </span>RTShader {
<a name="l00040"></a>00040 
<a name="l00048"></a>00048 <span class="preprocessor">#define SGX_LIB_PERPIXELLIGHTING                    &quot;SGXLib_PerPixelLighting&quot;</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_TRANSFORMNORMAL                    &quot;SGX_TransformNormal&quot;</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_TRANSFORMPOSITION                  &quot;SGX_TransformPosition&quot;</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_DIRECTIONAL_DIFFUSE          &quot;SGX_Light_Directional_Diffuse&quot;</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_DIRECTIONAL_DIFFUSESPECULAR  &quot;SGX_Light_Directional_DiffuseSpecular&quot;</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_POINT_DIFFUSE                &quot;SGX_Light_Point_Diffuse&quot;</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_POINT_DIFFUSESPECULAR        &quot;SGX_Light_Point_DiffuseSpecular&quot;</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_SPOT_DIFFUSE                 &quot;SGX_Light_Spot_Diffuse&quot;</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_SPOT_DIFFUSESPECULAR         &quot;SGX_Light_Spot_DiffuseSpecular&quot;    </span>
<a name="l00057"></a>00057 <span class="preprocessor"></span>
<a name="l00061"></a>00061 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> PerPixelLighting : <span class="keyword">public</span> SubRenderState
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="comment">// Interface.</span>
<a name="l00065"></a>00065 <span class="keyword">public</span>:
<a name="l00067"></a>00067     PerPixelLighting();
<a name="l00068"></a>00068 
<a name="l00072"></a>00072     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   getType                 () <span class="keyword">const</span>;
<a name="l00073"></a>00073 
<a name="l00077"></a>00077     <span class="keyword">virtual</span> <span class="keywordtype">int</span>             getExecutionOrder       () <span class="keyword">const</span>;
<a name="l00078"></a>00078 
<a name="l00082"></a>00082     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            updateGpuProgramsParams (Renderable* rend, Pass* pass, <span class="keyword">const</span> AutoParamDataSource* source, <span class="keyword">const</span> <a class="code" href="group__General.html#gaab30ef14aae93306a6044cb38d835f0c">LightList</a>* pLightList);
<a name="l00083"></a>00083 
<a name="l00087"></a>00087     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            copyFrom                (<span class="keyword">const</span> SubRenderState&amp; rhs);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00093"></a>00093     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            preAddToRenderState     (<span class="keyword">const</span> RenderState* renderState, Pass* srcPass, Pass* dstPass);
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096     
<a name="l00097"></a>00097     <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> Type;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="comment">// Protected types:</span>
<a name="l00100"></a>00100 <span class="keyword">protected</span>:
<a name="l00101"></a>00101     
<a name="l00102"></a>00102     <span class="comment">// Per light parameters.</span>
<a name="l00103"></a>00103     <span class="keyword">struct </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> LightParams
<a name="l00104"></a>00104     {
<a name="l00105"></a>00105         <a class="code" href="classOgre_1_1Light.html#a4f1dea084d1497c6f49e802ade940dbc" title="Defines the type of light.">Light::LightTypes</a>       mType;              <span class="comment">// Light type.      </span>
<a name="l00106"></a>00106         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mPosition;          <span class="comment">// Light position.</span>
<a name="l00107"></a>00107         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mDirection;         <span class="comment">// Light direction.</span>
<a name="l00108"></a>00108         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mAttenuatParams;    <span class="comment">// Attenuation parameters.</span>
<a name="l00109"></a>00109         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSpotParams;        <span class="comment">// Spot light parameters.</span>
<a name="l00110"></a>00110         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mDiffuseColour;     <span class="comment">// Diffuse colour.</span>
<a name="l00111"></a>00111         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSpecularColour;    <span class="comment">// Specular colour.</span>
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     };
<a name="l00114"></a>00114 
<a name="l00115"></a>00115     <span class="keyword">typedef</span> vector&lt;LightParams&gt;::type               LightParamsList;
<a name="l00116"></a>00116     <span class="keyword">typedef</span> LightParamsList::iterator               LightParamsIterator;
<a name="l00117"></a>00117     <span class="keyword">typedef</span> LightParamsList::const_iterator         LightParamsConstIterator;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="comment">// Protected methods</span>
<a name="l00120"></a>00120 <span class="keyword">protected</span>:
<a name="l00121"></a>00121 
<a name="l00127"></a>00127     <span class="keywordtype">void</span>                    setTrackVertexColourType(<a class="code" href="group__General.html#gaf3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours.">TrackVertexColourType</a> type) { mTrackVertexColourType = type; }
<a name="l00128"></a>00128 
<a name="l00132"></a>00132     <a class="code" href="group__General.html#gaf3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours.">TrackVertexColourType</a>   getTrackVertexColourType()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTrackVertexColourType; }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00139"></a>00139     <span class="keywordtype">void</span>                    setLightCount           (<span class="keyword">const</span> <span class="keywordtype">int</span> lightCount[3]);
<a name="l00140"></a>00140 
<a name="l00145"></a>00145     <span class="keywordtype">void</span>                    getLightCount           (<span class="keywordtype">int</span> lightCount[3]) <span class="keyword">const</span>;
<a name="l00151"></a>00151     <span class="keywordtype">void</span>                    setSpecularEnable       (<span class="keywordtype">bool</span> enable) { mSpecularEnable = enable; }
<a name="l00152"></a>00152 
<a name="l00156"></a>00156     <span class="keywordtype">bool</span>                    getSpecularEnable       ()<span class="keyword"> const      </span>{ <span class="keywordflow">return</span> mSpecularEnable; }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00162"></a>00162     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            resolveParameters           (ProgramSet* programSet);
<a name="l00163"></a>00163 
<a name="l00165"></a>00165     <span class="keywordtype">bool</span>                    resolveGlobalParameters     (ProgramSet* programSet);
<a name="l00166"></a>00166 
<a name="l00168"></a>00168     <span class="keywordtype">bool</span>                    resolvePerLightParameters   (ProgramSet* programSet);
<a name="l00169"></a>00169 
<a name="l00173"></a>00173     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            resolveDependencies     (ProgramSet* programSet);
<a name="l00174"></a>00174 
<a name="l00178"></a>00178     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            addFunctionInvocations  (ProgramSet* programSet);
<a name="l00179"></a>00179     
<a name="l00180"></a>00180 
<a name="l00184"></a>00184     <span class="keywordtype">bool</span>            addVSInvocation                     (Function* vsMain, <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span>&amp; internalCounter);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186     
<a name="l00190"></a>00190     <span class="keywordtype">bool</span>            addPSGlobalIlluminationInvocation   (Function* psMain, <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span>&amp; internalCounter);
<a name="l00191"></a>00191 
<a name="l00195"></a>00195     <span class="keywordtype">bool</span>            addPSIlluminationInvocation     (LightParams* curLightParams, Function* psMain, <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span>&amp; internalCounter);
<a name="l00196"></a>00196 
<a name="l00200"></a>00200     <span class="keywordtype">bool</span>            addPSFinalAssignmentInvocation  (Function* psMain, <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span>&amp; internalCounter);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 <span class="comment">// Attributes.</span>
<a name="l00204"></a>00204 <span class="keyword">protected</span>:  
<a name="l00205"></a>00205     <a class="code" href="group__General.html#gaf3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours.">TrackVertexColourType</a>   mTrackVertexColourType;         <span class="comment">// Track per vertex colour type.</span>
<a name="l00206"></a>00206     <span class="keywordtype">bool</span>                    mSpecularEnable;                <span class="comment">// Specular component enabled/disabled.</span>
<a name="l00207"></a>00207     LightParamsList         mLightParamsList;               <span class="comment">// Light list.</span>
<a name="l00208"></a>00208     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mWorldViewMatrix;               <span class="comment">// World view matrix parameter.</span>
<a name="l00209"></a>00209     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mWorldViewITMatrix;             <span class="comment">// World view matrix inverse transpose parameter.</span>
<a name="l00210"></a>00210     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSInPosition;                  <span class="comment">// Vertex shader input position parameter.</span>
<a name="l00211"></a>00211     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSOutViewPos;                  <span class="comment">// Vertex shader output view position (position in camera space) parameter.</span>
<a name="l00212"></a>00212     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSInViewPos;                   <span class="comment">// Pixel shader input view position (position in camera space) parameter.</span>
<a name="l00213"></a>00213     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSInNormal;                    <span class="comment">// Vertex shader input normal.</span>
<a name="l00214"></a>00214     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSOutNormal;                   <span class="comment">// Vertex shader output normal.</span>
<a name="l00215"></a>00215     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSInNormal;                    <span class="comment">// Pixel shader input normal.</span>
<a name="l00216"></a>00216     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSTempDiffuseColour;           <span class="comment">// Pixel shader temporary diffuse calculation parameter.</span>
<a name="l00217"></a>00217     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSTempSpecularColour;          <span class="comment">// Pixel shader temporary specular calculation parameter.</span>
<a name="l00218"></a>00218     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSDiffuse;                     <span class="comment">// Pixel shader input/local diffuse parameter.  </span>
<a name="l00219"></a>00219     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSSpecular;                    <span class="comment">// Pixel shader input/local specular parameter. </span>
<a name="l00220"></a>00220     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSOutDiffuse;                  <span class="comment">// Pixel shader output diffuse parameter.   </span>
<a name="l00221"></a>00221     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSOutSpecular;                 <span class="comment">// Pixel shader output specular parameter.  </span>
<a name="l00222"></a>00222     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mDerivedSceneColour;            <span class="comment">// Derived scene colour parameter.</span>
<a name="l00223"></a>00223     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mLightAmbientColour;            <span class="comment">// Ambient light colour parameter.</span>
<a name="l00224"></a>00224     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mDerivedAmbientLightColour;     <span class="comment">// Derived ambient light colour parameter.</span>
<a name="l00225"></a>00225     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSurfaceAmbientColour;          <span class="comment">// Surface ambient colour parameter.</span>
<a name="l00226"></a>00226     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSurfaceDiffuseColour;          <span class="comment">// Surface diffuse colour parameter.</span>
<a name="l00227"></a>00227     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSurfaceSpecularColour;         <span class="comment">// Surface specular colour parameter.</span>
<a name="l00228"></a>00228     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSurfaceEmissiveColour;         <span class="comment">// Surface emissive colour parameter.</span>
<a name="l00229"></a>00229     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSurfaceShininess;              <span class="comment">// Surface shininess parameter.</span>
<a name="l00230"></a>00230     <span class="keyword">static</span> Light            msBlankLight;                   <span class="comment">// Shared blank light.</span>
<a name="l00231"></a>00231 };
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00238"></a>00238 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> PerPixelLightingFactory : <span class="keyword">public</span> SubRenderStateFactory
<a name="l00239"></a>00239 {
<a name="l00240"></a>00240 <span class="keyword">public</span>:
<a name="l00241"></a>00241 
<a name="l00245"></a>00245     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   getType             () <span class="keyword">const</span>;
<a name="l00246"></a>00246 
<a name="l00250"></a>00250     <span class="keyword">virtual</span> SubRenderState* createInstance      (ScriptCompiler* compiler, PropertyAbstractNode* prop, Pass* pass, SGScriptTranslator* translator);
<a name="l00251"></a>00251 
<a name="l00255"></a>00255     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            writeInstance       (MaterialSerializer* ser, SubRenderState* subRenderState, Pass* srcPass, Pass* dstPass);
<a name="l00256"></a>00256 
<a name="l00257"></a>00257     
<a name="l00258"></a>00258 <span class="keyword">protected</span>:
<a name="l00259"></a>00259 
<a name="l00263"></a>00263     <span class="keyword">virtual</span> SubRenderState* createInstanceImpl  ();
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 };
<a name="l00267"></a>00267 
<a name="l00271"></a>00271 }
<a name="l00272"></a>00272 }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 <span class="preprocessor">#endif</span>
<a name="l00275"></a>00275 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
